
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_BASE_TWO_WAY_PERMUTATOR_H
#define PG_BASE_TWO_WAY_PERMUTATOR_H

#include "xstd/Array.h"

class RndPermutator;

// a 1:1 map of random numbers in a given range
// with direct and reverse lookup ability
class TwoWayPermutator {
	public:
		void configure(int mapSize, RndPermutator &rndPermutator, int seed);

		int directLookup(int n) const;  // returns 0 <= m < theMapSize
		int reverseLookup(int m) const; // returns 0 <= n < theMapSize

	protected:
		Array<int> theDirectMap;
		Array<int> theReverseMap;
};

#endif
