
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/gadgets.h"
#include "base/polyLogCats.h"
#include "runtime/ErrorMgr.h"
#include "runtime/polyErrors.h"
#include "client/CltXact.h"
#include "client/BodyParser.h"


BodyParser::BodyParser(): theOwner(0) {
}

BodyParser::~BodyParser() {
	resetSelf();
}

void BodyParser::configure(CltXact *anOwner) {
	Should(!theOwner ^ !anOwner);
	theOwner = anOwner;
}

void BodyParser::reset() {
	resetSelf();
}

void BodyParser::noteLeftovers(const ParseBuffer &leftovers) {
	ReportError(errContentLeftovers);
	theOwner->noteContent(leftovers);
}

void BodyParser::noteOverflow(const ParseBuffer &buf) {
	ReportError(errHugeContentToken);
	theOwner->noteContent(buf);
}

int BodyParser::logCat() const {
	return lgcCltSide;
}

ostream &BodyParser::dumpContext(ostream &os, const char *ctxBeg, Size ctxSize) const {
	const Size prnSize = Min(ctxSize, Size(60));
	os.write(ctxBeg, prnSize);
	if (prnSize < ctxSize)
		os << "...";
	return os;
}

void BodyParser::resetSelf() {
	theOwner = 0;
}
