
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_BODY_PARSER_H
#define PG_BODY_PARSER_H

#include "xstd/h/iosfwd.h"

class BodyParserFarm;
class ParseBuffer;
class CltXact;

// interface for various body parsers
class BodyParser {
	public:
		BodyParser();
		virtual ~BodyParser();

		void configure(CltXact *anOwner);

		virtual void reset();
		virtual BodyParserFarm &farm() const = 0;

		virtual Size parse(const ParseBuffer &data) = 0;
		virtual void noteLeftovers(const ParseBuffer &data);
		virtual void noteOverflow(const ParseBuffer &data);
		
	protected:
		int logCat() const;
		ostream &dumpContext(ostream &os, const char *ctxBeg, Size ctxSize) const;

	protected:
		CltXact *theOwner;

	private:
		void resetSelf();
};

#endif
