
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "client/CltDataFilterRegistry.h"


static CltDataFilterRegistry *TheRegistry = 0;


CltDataFilterRegistry::CltDataFilterRegistry():
	ModuleRegistry< DataFilter<CltXact*> >("client-side data filters") {
}

void CltDataFilterRegistry::apply(CltXact *xact, IOBuf &buf) {
	for (int i = 0; i < theModules.count(); ++i)
		theModules[i]->apply(xact, buf);
}

CltDataFilterRegistry &TheCltDataFilterRegistry() {
	Assert(TheRegistry);
	return *TheRegistry;
}

/* initialization */

int CltDataFilterRegistryInit::TheUseCount = 0;

void CltDataFilterRegistryInit::init() {
	TheRegistry = new CltDataFilterRegistry;
}

void CltDataFilterRegistryInit::clean() {
	delete TheRegistry;
	TheRegistry = 0;
}
