
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CLIENT_USER_GROUP_GNAME_ITER_H
#define PG_CLIENT_USER_GROUP_GNAME_ITER_H

#include "xstd/Interval.h"

class MembershipMap;

// iterates over group names for a specified group ID range
class MembershipGroupIterator {
	public:
		MembershipGroupIterator(const MembershipMap *aMap, Interval &aRange);

		bool atEnd() const { return !theRange.has(thePos); }
		operator void*() const { return atEnd() ? 0 : (void*)this; }
		String operator *() const;

		MembershipGroupIterator &operator ++();

	protected:
		void sync() {}
		void step() { ++thePos; }

	protected:
		const MembershipMap *theMembership;
		const Interval theRange;
		int thePos;
};

#endif
