
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_REGULAR_EXPRESSION_GROUP_H
#define PG_REGULAR_EXPRESSION_GROUP_H

#include "xstd/h/iosfwd.h"

class String;
class RegExExpr;
class RegExMatchee;
class Memberships;

// an interface for a group of REs with possibly optimized matching algorithm
class RegExGroup {
	public:
		static RegExGroup *FromExpr(RegExExpr *expr);

	public:
		virtual ~RegExGroup() {}

		virtual bool match(const RegExMatchee &matchee, int flags = 0, int *errNo = 0) const = 0;
		virtual ostream &print(ostream &os) const = 0;
};

class RegExMatchee {
	public:
		const char *url;
		const char *urlHost;
		const char *urlPath;
		const char *userName;
		const Memberships *memberships;
};

#endif
