
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CLIENT_SESSION_WATCH_REGISTRY_H
#define PG_CLIENT_SESSION_WATCH_REGISTRY_H

#include "runtime/ModuleRegistry.h"
#include "runtime/SessionWatch.h"
#include "runtime/BcastRcver.h"
#include "client/Client.h"

// registration handler for client-side data filters
class SessionWatchRegistry:  public ModuleRegistry< SessionWatch<Client> >,
	public BcastRcver {
	public:
		typedef void (Module::*Call)(const Client *c);

	public:
		SessionWatchRegistry();
		virtual ~SessionWatchRegistry();

		virtual void noteClientEvent(BcastChannel *ch, const Client *c);

	protected:
		void call(Call c, const Client *clt);
};

extern SessionWatchRegistry &TheSessionWatchRegistry();

LIB_INITIALIZER(SessionWatchRegistryInit)

#endif
