
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_WORKING_SET_SIZE_FREEZERS_H
#define PG_WORKING_SET_SIZE_FREEZERS_H

#include "xstd/AlarmClock.h"
#include "runtime/BcastRcver.h"
#include "client/WssFreezer.h"

// waits till the specified time and triggers ieWssFreeze event
class TimeWssFreezer: public WssFreezer, public AlarmUser {
	public:
		TimeWssFreezer(Time aDelay);

		virtual void start();
		virtual void wakeUp(const Alarm &alarm);

	protected:
		virtual void printGoal(ostream &os) const;

	protected:
		Time theDelay;
};

// waits until the specified fill count and triggers ieWssFreeze event
class FillWssFreezer: public WssFreezer, public BcastRcver {
	public:
		FillWssFreezer(int aFillCount);

		virtual void start();
		virtual void noteXactEvent(BcastChannel *, const Xaction *);
		virtual void noteInfoEvent(BcastChannel *ch, InfoEvent ev);

	protected:
		virtual void printGoal(ostream &os) const;

	protected:
		int theFillCount;
};

#endif
