
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "base/ObjId.h"
#include "base/RndPermut.h"
#include "runtime/IOBuf.h"
#include "csm/ContentCfg.h"
#include "csm/BodyIter.h"


BodyIter::BodyIter() {
	reset();
}

BodyIter::~BodyIter() {
	reset();
}

void BodyIter::configure(WrBuf *aBuf, Size aContSize) {
	Assert(theOid);
	theBuf = aBuf;
	theContSize = aContSize;
	theRng.seed(GlbPermut(theContentHash, rndBodyIter));
	theBuiltSize = 0;
}

void BodyIter::reset() {
	theOid.reset();
	theBuf = 0;
	theContSize = theBuiltSize = Size();
}

void BodyIter::pour() {
	if (theBuiltSize == 0)
		pourPrefix();
	pourBody();
}

void BodyIter::pourPrefix() {
	if (Should(theContentCfg && theBuf))
		theBuiltSize += theContentCfg->pourContentPrefix(theOid, *theBuf);
}
