
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_XML_TAG_IDENTIFIER_H
#define PG_XML_TAG_IDENTIFIER_H

#include "xstd/StrIdentifier.h"

// identifies tags (and their attributes) of interest
class XmlTagIdentifier {
	public:
		XmlTagIdentifier();
		~XmlTagIdentifier();

		void configure(Array<String*> &tags);

		int tagCount() const { return theTagIdx.count(); }

		bool findTag(const char *nameBeg, int nameLen, int &id) const;
		bool findAttr(int tagId, const char *nameBeg, int nameLen) const;

	protected:
		void addTag(const String &str);

	private:
		XmlTagIdentifier(const XmlTagIdentifier&);

	protected:
		StrIdentifier theTagIdx;
		Array<StrIdentifier*> theAttrIndeces;
};

#endif
