
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_INFORMATION_SCOPE_DIMENSION_H
#define PG_INFORMATION_SCOPE_DIMENSION_H

#include "xstd/String.h"
#include "xstd/Array.h"

class String;
class InfoScope;

// manages one dimension of InfoScope (e.g., phase dimention or side dimension)
class InfoScopeDim {
	friend class InfoScope;

	public:
		InfoScopeDim(const String &aLabel);
		InfoScopeDim(const InfoScopeDim &s);
		~InfoScopeDim();

		int count() const { return theNames.count(); }
		const Array<String*> &names() const { return theNames; }
		String image() const;

		void add(const String &name);
		bool has(const String &name) const;

	protected:
		void reset();
		void copy(const InfoScopeDim &s);

	protected:
		String theLabel;
		Array<String*> theNames;
};

#endif
