
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_INFORMATION_SCOPE_MAP_H
#define PG_INFORMATION_SCOPE_MAP_H

#include "xstd/String.h"
#include "xstd/Map.h"

class InfoScope;

// manages a collection of scopes indexed by their image
class InfoScopes {
	public:
		InfoScopes();
		~InfoScopes();

		int count() const { return theScopes.count(); }
		const InfoScope *scope(int idx) const { return theScopes[idx]; }
		const InfoScope *operator [](int idx) const { return scope(idx); }

		const InfoScope *find(const String &image) const;

		void add(const InfoScope &scope);
		void absorb(InfoScope *&scope);

	protected:
		Array<InfoScope*> theScopes;
		Map<int> theIndex;
};

#endif
