
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_PHASE_TRACE_H
#define PG_PHASE_TRACE_H

#include "base/StatIntvlRec.h"

class PhaseTraceWin {
	public:
		StatIntvlRec *stats;
		Time start;

		bool contains(Time tm) const;
};

// maintains trace data
class PhaseTrace {
	public:
		static Time TheWinLen;

	public:
		PhaseTrace();
		~PhaseTrace();

		void configure(const StatIntvlRec &stats);

		const StatIntvlRec &aggr() const { return theAggr; }

		int count() const { return theWins.count(); }
		const StatIntvlRec &winStats(int idx) const;
		Time winPos(int idx) const;
		Time start() const;

		void addIntvl(Time tm, const StatIntvlRec &r);
		void merge(const PhaseTrace &trace);
		void concat(const PhaseTrace &trace);

	protected:
		void mergeWin(const PhaseTraceWin &win);
		void concatWin(const PhaseTraceWin &win);
		PhaseTraceWin &allocWin(Time tm);
		bool findWin(Time tm, int &idx) const;

	protected:
		StatIntvlRec theAggr; // all intervals together
		Array<PhaseTraceWin> theWins;
};

#endif
