
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xml/XmlAttr.h"
#include "loganalyzers/ReportBlob.h"

ReportBlob::ReportBlob(const Key &aKey): XmlTag("report_blob"), theKey(aKey) {
	append(XmlAttr("key", aKey));
}

ReportBlob::ReportBlob(const ReportBlob &b): XmlTag(b), theKey(b.theKey) {
}

ReportBlob::~ReportBlob() {
}

XmlNode *ReportBlob::clone() const {
	return new ReportBlob(*this);
}
