
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_SOME_INFO_H
#define PG_SOME_INFO_H

#include "loganalyzers/InfoScope.h"

class String;
class BlobDb;
class ReportBlob;
class XmlAttr;

// common base for all report *Info classes
class SomeInfo {
	public:
		typedef InfoScope Scope;

	public:
		virtual ~SomeInfo() {}

	protected:
		const ReportBlob &addLink(BlobDb &db, const String &newKey, const String &oldKey);

		const ReportBlob &addMeasBlob(BlobDb &db, const String &name, double val, const String &unit);
		const ReportBlob &addMeasBlob(BlobDb &db, const String &name, Time val);
		const ReportBlob &addMeasBlob(BlobDb &db, const String &name, const String &val, const String &unit);

		const ReportBlob &addNaMeasBlob(BlobDb &db, const String &name);
};

#endif
