
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_AGGREGATE_INFO_LOADER_H
#define PG_AGGREGATE_INFO_LOADER_H

#include "base/StatPhaseRec.h"

class PhaseGroup: public StatPhaseRec {
	public:
		PhaseGroup(const String &aName);
};

class AggrInfoLoader {
	protected:
		typedef const Array<String*> &Strs;

	public:
		AggrInfoLoader(Strs phaseNames);
		virtual ~AggrInfoLoader();

		void filter(LogCatFilter *aFilter) { theFilter = aFilter; }

		bool load(ILog &il, const LogEntryPx &px);

		int groupCount() const;
		const PhaseGroup *group(const String &name) const;
		const PhaseGroup *group(int idx) const;
		int aggregate(StatPhaseRec &r) const;

	protected:
		virtual void notePhase(const StatPhaseRec &ph);
		void addCat(int cat);

	protected:
		Strs thePhaseNames;

		Array<PhaseGroup*> theGroups;
		LogCatFilter *theFilter;
};

#endif
