
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_ACL_SYMBOL_H
#define PG_ACL_SYMBOL_H

#include "pgl/PglRecSym.h"

class String;
class RegExExpr;

// access control "list"
class AclSym: public RecSym {
	public:
		static String TheType;

	public:
		AclSym();
		AclSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		RegExExpr *allow() const;
		RegExExpr *deny() const;
		RegExExpr *rewrite() const;
		bool checkDomestic(double &prob) const;
		bool checkForeign(double &prob) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

		RegExExpr *getGroup(const String &name) const;
};

#endif
