
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglRec.h"
#include "pgl/LogSym.h"



String LogSym::TheType = "Log";

static String strFname = "fname";


LogSym::LogSym(): RecSym(TheType, new PglRec) {
	theRec->bAdd(StringSym::TheType, strFname, 0);
	theRec->bAdd(SizeSym::TheType,  strSize, 0);
}

LogSym::LogSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
}

bool LogSym::isA(const String &type) const {
	return RecSym::isA(type) ||	type == TheType;
}

SynSym *LogSym::dupe(const String &type) const {
	if (isA(type))
		return new LogSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}
