
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_PROXY_SYMBOL_H
#define PG_PROXY_SYMBOL_H

#include "pgl/AgentSym.h"

class RobotSym;
class ServerSym;
class CacheSym;

// server side configuration
class ProxySym: public AgentSym {
	public:
		static const String TheType;

	public:
		ProxySym();
		ProxySym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		RobotSym *client() const;
		ServerSym *server() const;
		AgentSym *side(const String &sideType) const;
		CacheSym *cache() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
		virtual String msgTypesField() const;
};

#endif
