
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "runtime/HostMap.h"
#include "runtime/Viservs.h"


ViservIterator::ViservIterator(): theIdx(0) {
	sync();
}

bool ViservIterator::atEnd() const {
	return theIdx >= TheHostMap->iterationCount();
}

int ViservIterator::viserv() const {
	return theIdx;
}

HostCfg *ViservIterator::host() const {
	return TheHostMap->at(theIdx);
}

const NetAddr &ViservIterator::addr() const {
	return host()->theAddr;
}

PubWorld *ViservIterator::pubWorld() const {
	return host()->thePubWorld;
}

ViservIterator &ViservIterator::operator ++() {
	next();
	return *this;
}

void ViservIterator::next() {
	theIdx++;
	sync();
}

void ViservIterator::sync() {
	for (; !atEnd(); ++theIdx) {
		HostCfg *host = TheHostMap->at(theIdx);
		if (host && host->thePubWorld)
			return;
	}	
}
