
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_HTTP_TEXT_H
#define PG_HTTP_TEXT_H

#include "xstd/String.h"

// various HTTP header strings

// protocol strings
extern const String protoHttp1p0;
extern const String protoHttp1p1;

// request line prefixes
extern const String rlpGet;
extern const String rlpHead;
extern const String rlpPost;
extern const String rlpPut;
extern const String rlpConnect;

// request line suffixes: protocol version and spaces
extern const String rlsHttp1p0;
extern const String rlsHttp1p1;

// response line suffix: status code and reason phrase
extern const String rls200Ok;
extern const String rls302Found;
extern const String rls304NotModified;

// full header fields
extern const String hfAccept;
extern const String hfConnAliveOrg;
extern const String hfConnCloseOrg;
extern const String hfConnAlivePxy;
extern const String hfConnClosePxy;
extern const String hfReload;
extern const String hfCcCachable;
extern const String hfCcUncachable;

// header field prefixes
extern const String hfpCacheControl;
extern const String hfpConnection;
extern const String hfpPragma;
extern const String hfpProxyConnection;
extern const String hfpTransferEncoding;
extern const String hfpHost;
extern const String hfpIMS;
extern const String hfpXLocWorld;
extern const String hfpXRemWorld;
extern const String hfpXXact;
extern const String hfpXTarget;
extern const String hfpXAbort;
extern const String hfpXPhaseSyncPos;
extern const String hfpContLength;
extern const String hfpContMd5;
extern const String hfpContType;
extern const String hfpDate;
extern const String hfpExpires;
extern const String hfpLmt;
extern const String hfpServer;
extern const String hfpLocation;
extern const String hfpProxyAuthorization;
extern const String hfpXRemWorld;
extern const String hfpXXact;
extern const String hfpXTarget;

// free text
extern const String text302Found;

#endif
